; Q68 Send a command to an SDHC   1.00  W. Lenerz 2017

	section dv3

	xdef	snd_cmd

	include 'DEV8_keys_err'
	include 'DEV1_q68_qlsd_keys'

;+++
; This routine sends a command to an sdhc card. The command is 6 bytes long.
; On entry d0 contains the first 4 bytes and d1.w the last two.
;
;	d0 cr	first 4 command bytes / error code
;	d1 cr	.W : 2 last command bytes / return byte
;	d3    s
;	a2 c  p pointer to interface base
;	a3    s
;
;	status return 0 or ERR.MCHK (card didn't reply correctly)
;---

snd_cmd
	move.l	a2,-(a7)
	move.l	#SPI_XFER,a2
	move.w	#255,d3
	tst.b	(a2,d3.w)	; send some pulses
	rol.l	#8,d0
	move.b	d0,d3
	tst.b	(a2,d3.w)	; send first byte
	rol.l	#8,d0
	move.b	d0,d3
	tst.b	(a2,d3.w)	; send 2nd byte
	rol.l	#8,d0
	move.b	d0,d3
	tst.b	(a2,d3.w)	; send 3rd byte
	rol.l	#8,d0
	move.b	d0,d3
	tst.b	(a2,d3.w)	; send 4th byte

	ror.w	#8,d1
	move.b	d1,d3
	tst.b	(a2,d3.w)	; send fifth byte
	rol.w	#8,d1
	move.b	d1,d3
	tst.b	(a2,d3.w)	; send 6th & last byte

	move.l	#SPI_BG_READ,a2
	move.l	(a7),a3 	; I/F base
	add.w	#SPI_READ,a3

	move.w	#250,d3 	; *** was 150 ***
sdcmdlp tst.b	(a2)
	move.b	(a3),d1 	; get reply, which must be <> -1 to be valid
	cmp.b	#-1,d1		; is it valid?
	bne.s	got_rply	; ...yes, done
	dbf	d3,sdcmdlp	; ...no, try again
	moveq	#err.mchk,d0	; card didn't reply in time
	move.l	(a7)+,a2
	rts
got_rply
	moveq	#0,d0
	move.l	(a7)+,a2
	rts

	end
