; DV3 Q68 SDHC (WIN) Driver initialisation 1.00  W. Lenerz 2016 - 2017
;
; based on
;
; DV3 Q40 IDE Initialisation  V3.00    1992  Tony Tebby
;
; !!! non s0andard linkage block size


	section dv3

	xdef	win_init		; inits the driver

	xref	dv3_link
	xref	dv3_acdef
	xref	norm_nm
;	 xref	 inicrd
;	 xref	 cpy2mem

	xref	gu_fopen
	xref	gu_fclos

	include 'dev8_dv3_keys'
	include 'dev8_dv3_hd_keys'
	include 'dev8_dv3_mac'
	include 'dev8_mac_assert'
	include 'dev8_mac_basic'
	include 'dev8_mac_proc'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_q68'
	include 'dev8_smsq_smsq_base_keys'
	include 'dev8_mac_MultiConfig02'

;++++++++++++++++++++
; DV3 Q68 SDHC (WIN) driver initialisation
;
;	a3  r	device driver linkage
;--------------------
win_init
	lea	hd_table,a3
	jsr	dv3_link		; link in driver
	tst.l	d0
	bne.s	out			; ooops!

;	 move.l  #'MDV0',ddl_dnuse+2(a3)

; fill in data about the drives/cards in the device defn block, see keys_q68
	lea	hdl_unit(a3),a1
	move.l	#$01010101,d0
	move.l	d0,(a1)+
	move.l	d0,(a1)+
; copy the pre configured name for drive 1
	lea	hdl_end(a3),a1
	lea	qsd_wn1,a0
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	lea	qsdlb1,a1
	move.l	(a1),d0
	andi.l	#$dfdfdf00,d0
	move.l	d0,ddl_dnuse+2(a3)	; current usage
	moveq	#0,d0			; done
out	rts

my_len	equ	hdl_end+128		; space for 8 drive names

hd_table
	link_table	WIN, '1', my_len, ddf_dtop
	buffered			; commenting out results in a not working drive
	sectl		512
	mtype		ddl.hd
	msect		255		; this will still use slave blocks for simple reads
	density 	ddf.dd

	poll		hd_poll_check

	check		hd_check
	direct		hd_direct
	rsect		hd_rdirect
	wsect		hd_wdirect
	slbfill 	hd_slbfill
	slbupd		hd_slbupd
	dflush		hd_dflush
	fflush		hd_fflush
;;;	fslave		hd_fslave
	mformat 	hd_mformat
	status		hd_fstatus
	done		hd_done

;;	  thing 	  hd_tname,hd_thing

	preset_b	hdl_apnd-1, 0,hdl.apnd
	preset_b	hdl_maxd, hdl.maxd, 0
	preset_w	hdl_paus,30

	preset_b	hdl_part,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	preset_b	hdl_remd,1,1,1,1,1,1,1,1

	preset_v	hdl_rsint,hd_rsint
	preset_v	hdl_wsint,hd_wsint
	preset_v	hdl_ckrdy,hd_ckrdy
	preset_v	hdl_ckwp,hd_ckwp
	preset_v	hdl_lock,hd_lock
	preset_v	hdl_unlock,hd_unlock
	preset_v	hdl_ststp,hd_ststp

	link_end	hdl_buff


qsd_wn1 dc.w	'QXL     WIN'		; normalized name
qsd_wn2 dc.w	13,7
	dc.w	'QXL.WIN',0,0		; config name

qsd_wn3 dc.w	4,3			; device usage name
qsdlb1	dc.w	'MDV'

smsq_vers  equ '1.00'

	mkcfstart

	 mkcfhead {WIN drive},{smsq_vers}

	   mkcfitem 'QSD1',string,0,qsd_wn2,,ppr,{Filename for WIN1},0
	   mkcfitem 'QSD2',string,0,qsd_wn3,,,{Initial device name},0
	  
	 mkcfblend

	mkcfend

; post processing routine to make sure that a name is a valid 8.3 name
ppr	tst.b	d1
	beq.s	p_ok2
	addq.l	#2,a0			; point to item name
	move.l	a0,d7
	move.w	(a0)+,d2		; length
	beq.s	p_ok			; 0 length is fine
	cmp.w	#12,d2			; max chars allowed (8+3+extn)
	bgt.s	ipar			; too many
	subq.w	#1,d2			; prepare for dbf
	moveq	#'.',d5 		; compare with this
	moveq	#0,d6			; nbr of chars compared till now
p_lp1	cmp.b	(a0)+,d5		; try to find extension marker
	beq.s	extn			; found it, check name
	addq.l	#1,d6			; new number of chars checked
	dbf	d2,p_lp1		; check all chars
; if we get here, there is no extension
	subq.w	#8,d6			; max nbr of chars w/o extn allowed
	ble.s	p_ok			; correct name w/ extn
	bra.s	ipar			; wrong name
; d2 nbr of chars remaining
; d6 nbr of chars before extension
extn
	subq.w	#8,d6			; nbr of chars got before extn
	bgt.s	ipar			; too many chars before the extension
	cmp.w	#3,d2			; how many chars remaining for the extn?
	bgt.s	ipar			; too many!
p_ok	move.l	d7,a0			;
	move.l	a1,d7
	lea	qsd_wn1,a1
	bsr	norm_nm 		; normalize name
	move.l	d7,a1
p_ok2	moveq	#0,d0
	rts
ipar	moveq	#err.inam,d0
	rts

	end
